// ################################################################################################################################################################# //
// ###                                                          STEROWNIK SEGMENTU NR 1 MAKIETY "STACJA WYSOKA"
// ###
// ###                                                                                                                                          Klaudiusz Dawid 2020
// ################################################################################################################################################################# //

#include <Servo.h>
Servo serwo_1;
Servo serwo_2;
Servo serwo_wyk;

#define przekaznik_1     A4
#define przekaznik_2     A5

#define A_czerwone        5
#define A_zielone         6
#define A_pomaranczowe_1  7
#define A_pomaranczowe_2  8
#define A_biale           9

#define B_biale           10
#define B_zielone         11
#define B_czerwone        12

#define C_czerwone        A3
#define C_zielone         A2
#define C_pomaranczowe    A1
#define C_biale           A0

int data, migacz;
int pozycja_serwo_1, pozycja_serwo_2, pozycja_serwo_wyk;
int miganie_biale_A = 0;
int miganie_biale_B = 0;
int miganie_biale_C = 0;
int miganie_pomaranczowe_A = 0;

unsigned long czas;
unsigned long czas_miganie = 1000;



// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------   S E T U P   ----------------------------------------------------------------------
void setup() {
  Serial.begin(9600);

  serwo_1.attach(2);
  serwo_1.write(20);  // pozycja na wprost //
  serwo_2.attach(3);
  serwo_2.write(20);  // pozycja na wprost //
  serwo_wyk.attach(4);
  serwo_wyk.write(20);  // pozycja otwarta //

  pinMode(przekaznik_1, OUTPUT);
  digitalWrite(przekaznik_1, LOW);
  pinMode(przekaznik_2, OUTPUT);
  digitalWrite(przekaznik_2, LOW);

  pinMode(A_czerwone, OUTPUT);
  pinMode(A_zielone, OUTPUT);
  pinMode(A_pomaranczowe_1, OUTPUT);
  pinMode(A_pomaranczowe_2, OUTPUT);
  pinMode(A_biale, OUTPUT);
  digitalWrite(A_czerwone, HIGH);
  digitalWrite(A_zielone, LOW);
  digitalWrite(A_pomaranczowe_1, LOW);
  digitalWrite(A_pomaranczowe_2, LOW);
  digitalWrite(A_biale, LOW);

  pinMode(B_czerwone, OUTPUT);
  pinMode(B_zielone, OUTPUT);
  pinMode(B_biale, OUTPUT);
  digitalWrite(B_czerwone, HIGH);
  digitalWrite(B_zielone, LOW);
  digitalWrite(B_biale, LOW);

  pinMode(C_czerwone, OUTPUT);
  pinMode(C_zielone, OUTPUT);
  pinMode(C_pomaranczowe, OUTPUT);
  pinMode(C_biale, OUTPUT);
  digitalWrite(C_czerwone, HIGH);
  digitalWrite(C_zielone, LOW);
  digitalWrite(C_pomaranczowe, LOW);
  digitalWrite(C_biale, LOW);

} // koniec bloku setup //




// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------   O D C Z Y T   S E R I A L A   ------------------------------------------------------------
void odczyt_seriala()
{
  data = Serial.parseInt();
  delay(10);

  // ------------------------------------------- ROZJAZD Zw1 ---------------------------- //
  if (data == 1011)                         // serwo 1 na wprost //
  {
    if (pozycja_serwo_1 >= 98)
    {
      for (pozycja_serwo_1 = 100; pozycja_serwo_1 >= 20; pozycja_serwo_1 -- )
      {
        serwo_1.write(pozycja_serwo_1);
        delay(10);
        if (pozycja_serwo_1 < 60) digitalWrite(przekaznik_1, LOW);
        if (pozycja_serwo_1 < 22) Serial.println(4011);
      }
    }
  } // 1011 //

  if (data == 1012)                         // serwo 1 na bok //
  {
    if (pozycja_serwo_1 <= 21)
    {
      for (pozycja_serwo_1 = 20; pozycja_serwo_1 <= 100; pozycja_serwo_1 ++ )
      {
        serwo_1.write(pozycja_serwo_1);
        delay(10);
        if (pozycja_serwo_1 > 60) digitalWrite(przekaznik_1, HIGH);
        if (pozycja_serwo_1 > 98) Serial.println(4012);
      }
    }
  } // 1012 //





  // ------------------------------------------- ROZJAZD Zw2 ---------------------------- //
  if (data == 1021)                         // serwo 2 na wprost //
  {
    if (pozycja_serwo_2 >= 98)
    {
      for (pozycja_serwo_2 = 100; pozycja_serwo_2 >= 20; pozycja_serwo_2 -- )
      {
        serwo_2.write(pozycja_serwo_2);
        delay(10);
        if (pozycja_serwo_2 < 60) digitalWrite(przekaznik_2, LOW);
        if (pozycja_serwo_2 < 22) Serial.println(4021);
      }
    }
  } // 1021 //

  if (data == 1022)                         // serwo 2 na bok //
  {
    if (pozycja_serwo_2 <= 21)
    {
      for (pozycja_serwo_2 = 20; pozycja_serwo_2 <= 100; pozycja_serwo_2 ++ )
      {
        serwo_2.write(pozycja_serwo_2);
        delay(10);
        if (pozycja_serwo_2 > 60) digitalWrite(przekaznik_2, HIGH);
        if (pozycja_serwo_2 > 98) Serial.println(4022);
      }
    }
  } // 1022 //



  // ------------------------------------------- WYKOLEJNICA ---------------------------- //
  if (data == 1031)                         // serwo wyk otwarta //
  {
    if (pozycja_serwo_wyk >= 98)
    {
      for (pozycja_serwo_wyk = 100; pozycja_serwo_wyk >= 20; pozycja_serwo_wyk -- )
      {
        serwo_wyk.write(pozycja_serwo_wyk);
        delay(10);
        if (pozycja_serwo_wyk < 22) Serial.println(4031);
      }
    }
  } // 1031 //


  if (data == 1032)                         // serwo wyk zamknieta //
  {
    if (pozycja_serwo_wyk <= 21)
    {
      for (pozycja_serwo_wyk = 20; pozycja_serwo_wyk <= 100; pozycja_serwo_wyk ++ )
      {
        serwo_wyk.write(pozycja_serwo_wyk);
        delay(10);
        if (pozycja_serwo_wyk > 98) Serial.println(4032);
      }
    }
  } // 1032 //




  // ------------------------------------------- SEMAFOR A ---------------------------- //
  if (data == 1041) // A czerwone >> S_1 //
  {
    digitalWrite(A_czerwone, HIGH);
    digitalWrite(A_zielone, LOW);
    digitalWrite(A_pomaranczowe_1, LOW);
    digitalWrite(A_pomaranczowe_2, LOW);
    digitalWrite(A_biale, LOW);
    miganie_biale_A = 0;
    miganie_pomaranczowe_A = 0;
    Serial.println(4041);
  }

  if (data == 1042) // A zielone >> S_2 //
  {
    digitalWrite(A_czerwone, LOW);
    digitalWrite(A_zielone, HIGH);
    digitalWrite(A_pomaranczowe_1, LOW);
    digitalWrite(A_pomaranczowe_2, LOW);
    digitalWrite(A_biale, LOW);
    miganie_biale_A = 0;
    miganie_pomaranczowe_A = 0;
    Serial.println(4042);
  }

  if (data == 1043) // A biale >> Sz //
  {
    digitalWrite(A_czerwone, HIGH);
    digitalWrite(A_zielone, LOW);
    digitalWrite(A_pomaranczowe_1, LOW);
    digitalWrite(A_pomaranczowe_2, LOW);
    digitalWrite(A_biale, HIGH);
    miganie_biale_A = 1;
    miganie_pomaranczowe_A = 0;
    Serial.println(4043);
  }

  if (data == 1044) // A pomaranczowe_1 >> S_5 //
  {
    digitalWrite(A_czerwone, LOW);
    digitalWrite(A_zielone, LOW);
    digitalWrite(A_pomaranczowe_1, HIGH);
    digitalWrite(A_pomaranczowe_2, LOW);
    digitalWrite(A_biale, LOW);
    miganie_biale_A = 0;
    miganie_pomaranczowe_A = 0;
    Serial.println(4044);
  }

  if (data == 1045) // A 2*pomaranczowe >> S_13 //
  {
    digitalWrite(A_czerwone, LOW);
    digitalWrite(A_zielone, LOW);
    digitalWrite(A_pomaranczowe_1, HIGH);
    digitalWrite(A_pomaranczowe_2, HIGH);
    digitalWrite(A_biale, LOW);
    miganie_biale_A = 0;
    miganie_pomaranczowe_A = 0;
    Serial.println(4045);
  }

  if (data == 1046) // A 2*pomaranczowe >> S_12 //
  {
    digitalWrite(A_czerwone, LOW);
    digitalWrite(A_zielone, LOW);
    digitalWrite(A_pomaranczowe_1, HIGH);
    digitalWrite(A_pomaranczowe_2, HIGH);
    digitalWrite(A_biale, LOW);
    miganie_biale_A = 0;
    miganie_pomaranczowe_A = 1;
    Serial.println(4046);
  }

  if (data == 1047) // A zielone/pomaranczowe >> S_10 //
  {
    digitalWrite(A_czerwone, LOW);
    digitalWrite(A_zielone, HIGH);
    digitalWrite(A_pomaranczowe_1, LOW);
    digitalWrite(A_pomaranczowe_2, HIGH);
    digitalWrite(A_biale, LOW);
    miganie_biale_A = 0;
    miganie_pomaranczowe_A = 0;
    Serial.println(4047);
  }



  // ------------------------------------------- SEMAFOR B ---------------------------- //
  if (data == 1051) // B czerwone >> S_1 //
  {
    digitalWrite(B_czerwone, HIGH);
    digitalWrite(B_zielone, LOW);
    digitalWrite(B_biale, LOW);
    miganie_biale_B = 0;
    Serial.println(4051);
  }

  if (data == 1052) // B zielone >> S_2 //
  {
    digitalWrite(B_czerwone, LOW);
    digitalWrite(B_zielone, HIGH);
    digitalWrite(B_biale, LOW);
    miganie_biale_B = 0;
    Serial.println(4052);
  }

  if (data == 1053) // B biale >> Sz //
  {
    digitalWrite(B_czerwone, HIGH);
    digitalWrite(B_zielone, LOW);
    digitalWrite(B_biale, HIGH);
    miganie_biale_B = 1;
    Serial.println(4053);
  }


  // ------------------------------------------- SEMAFOR C ---------------------------- //
  if (data == 1061) // C czerwone >> S_1 //
  {
    digitalWrite(C_czerwone, HIGH);
    digitalWrite(C_zielone, LOW);
    digitalWrite(C_pomaranczowe, LOW);
    digitalWrite(C_biale, LOW);
    miganie_biale_C = 0;
    Serial.println(4061);
  }

  if (data == 1062) // C zielone >> S_2 //
  {
    digitalWrite(C_czerwone, LOW);
    digitalWrite(C_zielone, HIGH);
    digitalWrite(C_pomaranczowe, LOW);
    digitalWrite(C_biale, LOW);
    miganie_biale_C = 0;
    Serial.println(4062);
  }

  if (data == 1063) // C biale >> Sz //
  {
    digitalWrite(C_czerwone, HIGH);
    digitalWrite(C_zielone, LOW);
    digitalWrite(C_pomaranczowe, LOW);
    digitalWrite(C_biale, HIGH);
    miganie_biale_C = 1;
    Serial.println(4063);
  }

  if (data == 1064) // C zielone/pomaranczowe >> S_10 //
  {
    digitalWrite(C_czerwone, LOW);
    digitalWrite(C_zielone, HIGH);
    digitalWrite(C_pomaranczowe, HIGH);
    digitalWrite(C_biale, LOW);
    miganie_biale_C = 0;
    Serial.println(4064);
  }

} // koniec bloku odczyt seriala //





// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------   L O O P   ------------------------------------------------------------------------
void loop()
{
  czas = millis();

  if (Serial.available() > 0)odczyt_seriala();

  if (czas_miganie < czas)
  {
    migacz++;
    if (migacz > 1)migacz = 0;
    czas_miganie = czas + 700;
  }


  if (miganie_biale_A == 1)
  {
    if (migacz == 0) digitalWrite(A_biale, LOW);
    if (migacz == 1)digitalWrite(A_biale, HIGH);
  }

  if (miganie_biale_B == 1)
  {
    if (migacz == 0) digitalWrite(B_biale, LOW);
    if (migacz == 1)digitalWrite(B_biale, HIGH);
  }

  if (miganie_biale_C == 1)
  {
    if (migacz == 0) digitalWrite(C_biale, LOW);
    if (migacz == 1)digitalWrite(C_biale, HIGH);
  }

  if (miganie_pomaranczowe_A == 1)
  {
    if (migacz == 0) digitalWrite(A_pomaranczowe_1, LOW);
    if (migacz == 1)digitalWrite(A_pomaranczowe_1, HIGH);
  }

} // koniec petli glownej //
