// ################################################################################################################################################################# //
// ###                                                          STEROWNIK SEGMENTU NR 2 MAKIETY "STACJA WYSOKA"
// ###
// ###                                                                                                                                          Klaudiusz Dawid 2020
// ################################################################################################################################################################# //

#include <Servo.h>
Servo serwo_3;
Servo serwo_4;

#define przekaznik_3     4
#define przekaznik_4     5

int data;
int pozycja_serwo_3, pozycja_serwo_4;



// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------   S E T U P   ----------------------------------------------------------------------
void setup() {
  Serial.begin(9600);

  serwo_3.attach(2);
  serwo_3.write(20);  // pozycja na wprost //
  serwo_4.attach(3);
  serwo_4.write(20);  // pozycja na wprost //

  pinMode(przekaznik_3, OUTPUT);
  digitalWrite(przekaznik_3, LOW);
  pinMode(przekaznik_4, OUTPUT);
  digitalWrite(przekaznik_4, LOW);

} // koniec bloku setup //




// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------   O D C Z Y T   S E R I A L A   ------------------------------------------------------------
void odczyt_seriala()
{
  data = Serial.parseInt();
  delay(10);

  // ------------------------------------------- ROZJAZD Zw3 + Zw4 ---------------------------- //

  if (data == 2011)                         // serwo 3 na wprost + serwo 4 na wprost //
  {
    if (pozycja_serwo_3 >= 98)
    {
      for (pozycja_serwo_3 = 100; pozycja_serwo_3 >= 20; pozycja_serwo_3 -- )
      {
        serwo_3.write(pozycja_serwo_3);
        delay(10);
        if (pozycja_serwo_3 < 60) digitalWrite(przekaznik_3, LOW);
      }
    }

    if (pozycja_serwo_4 >= 98)
    {
      for (pozycja_serwo_4 = 100; pozycja_serwo_4 >= 20; pozycja_serwo_4 -- )
      {
        serwo_4.write(pozycja_serwo_4);
        delay(10);
        if (pozycja_serwo_4 < 60) digitalWrite(przekaznik_4, LOW);
        if ( pozycja_serwo_4 < 22) Serial.println(5011);
      }
    }


  } // 2011 //




  if (data == 2012)                         // serwo 3 na bok + serwo 4 na bok //
  {
    if (pozycja_serwo_3 <= 21)
    {
      for (pozycja_serwo_3 = 20; pozycja_serwo_3 <= 100; pozycja_serwo_3 ++ )
      {
        serwo_3.write(pozycja_serwo_3);
        delay(10);
        if (pozycja_serwo_3 > 60) digitalWrite(przekaznik_3, HIGH);
      }
    }

    if (pozycja_serwo_4 <= 21)
    {
      for (pozycja_serwo_4 = 20; pozycja_serwo_4 <= 100; pozycja_serwo_4 ++ )
      {
        serwo_4.write(pozycja_serwo_4);
        delay(10);
        if (pozycja_serwo_4 > 60) digitalWrite(przekaznik_4, HIGH);
        if ( pozycja_serwo_4 > 98) Serial.println(5012);
      }
    }


  } // 2012 //

} // odczyt seriala //





// -----------------------------------------------------------------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------   L O O P   ------------------------------------------------------------------------
void loop()
{
  if (Serial.available() > 0)odczyt_seriala();

} // koniec petli glownej //
